#!/bin/sh

# MountAdd - Add a new mount point and mount a filesystem

# NOTE:  If you modify this code, you MUST change the version to
#        something over 100 to prevent it being replaced by future
#        versions of this script. 
VER=0.18
export VER

# If we have input args look for -v
case "$1" in

'-v')
    echo $VER
    exit 0
    ;;

'-1')
    echo "1"
    exit 0
    ;;
esac

MNT=$1

if [ -f ${MNT} ]; then
	echo "ERROR:  Cannot mount on top of a file, must be a directory"
	exit 1
fi

if [ ! -d ${MNT} ]; then
	mkdir -p ${MNT} 2>/dev/null
	if [ $? -ne 0 ]                                                                 
	then
		echo "ERROR:  Cannot make the necessary mount point"
		exit 1
	fi
fi
	
mount ${MNT} 2> /dev/null
if [ $? -ne 0 ]                                                                 
then
	echo "ERROR:  Cannot mount directory!"
	exit 1
fi

exit 0




