#!/bin/sh

#  This is to be run from $MATHOME/tmp.  The upgrade files should be in 
#  the same location.

# NOTE:  Do NOT modify this script it will be overwritten when the
#        next upgrade is applied

NEW=0.18
export NEW

# If we have input args look for -v
case "$1" in

'-v')
    echo $NEW
    exit 0
    ;;

'-1')
    echo "1"
    exit 0
    ;;
esac


MATHOME="../"
MATBIN="../bin"
MATTMP="../tmp"
MATSRC="../scripts"

# Run through all the files in the catalog and compare versions
for i in `cat $MATTMP/catalog` ;
do
    # The older versions of the scripts did not support "-v", so
    # we have to replace them blindly

    echo "Upgrading MAT script $i"
    mv $MATTMP/$i $MATSRC/$i
    chmod 755 $MATSRC/$i


# The code below is only for upgrading 0.18 or higher.  It will fail on 0.17 or lower
#
#    CVER=`$MATTMP/$i -v`
#    if [ -f $MATSRC/$i ]; then
#	VER=`$MATSRC/$i -v |awk -F' ' '{ print $1 }'`
#	if [ `expr $CVER > $VER` ]; then
#	    echo "Upgrading MAT script $i.  Old version $VER.  New version $CVER"
#	    mv $MATTMP/$i $MATSRC/$i
#	    chmod 755 $MATSRC/$i
#	else
#	    echo "No upgrade of $i.  Old version $VER.  New version $CVER"
#	    rm $MATTMP/$i
#	fi
#    else
#	echo "MAT script $i not found.  Adding."
#	mv $MATTMP/$i $MATSRC/$i
#	chmod 755 $MATSRC/$i
#    fi

done
rm catalog


# Upgrade tape Library
mv $MATTMP/libtape.so $MATBIN/libtape.so
chmod 755 $MATBIN/libtape.so


# Upgrade the MATd binary
if [ -f $MATBIN/matd ]; then
    VER=`$MATBIN/matd -v |awk -F' ' '{ print $1 }'`
    if [ `expr $NEW > $VER` ]; then
	echo "Upgrading MATd"
	mv $MATTMP/matd $MATBIN/matd
    else
	echo "No need to upgrade MATd"
	rm $MATTMP/matd
    fi
else
    echo "MATd not found.  Adding."
    mv $MATTMP/matd $MATBIN/matd
fi
chmod 755 $MATBIN/matd

# Terminate communications with the MAT console, before 
# trying to replace the matagent binary
echo "TRANSFER OK"
sleep 1


# Upgrade the MAT agent binary
if [ -f $MATBIN/matagent ]; then
    VER=`$MATBIN/matagent -v |awk -F' ' '{ print $1 }'`
    if [ `expr $NEW > $VER` ]; then
	echo "Upgrading MAT agent"
	mv $MATTMP/matagent $MATBIN/matagent
    else
	echo "No need to upgrade MAT agent"
	rm $MATTMP/matagent
    fi
else
    echo "MAT agent not found.  Adding."
    mv $MATTMP/matagent $MATBIN/matagent
fi
chmod 755 $MATBIN/matagent





